#ifndef INCLUDED_NIBCONTROLLER_H
#define INCLUDED_NIBCONTROLLER_H
//
//  NIBController.h
//  DynamicNIB
//
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class NIBManager;
@class NIBContext;
@class MetadataParser;

/**
Some documentation
*/

@interface NIBController : NSObject {

    NIBManager *			manager;
    NSManagedObjectModel *  model;
	NSMutableArray *		controllers;
	NSMutableDictionary *	menus;
    NSView *				window;
}


- (NIBManager *)manager;
- (NSManagedObjectModel *)model;
- (NSMutableArray *)controllers;
- (NSMutableDictionary *)menus;
- (NSView *)window;
- (void)setManager:(NIBManager *)myManager;
- (void)setModel:(NSManagedObjectModel *)myModel;
- (void)setControllers:(NSMutableArray *)myControllers;
- (void)setMenus:(NSMutableDictionary *)myMenus;
- (void)setWindow:(NSView *)myWindow;
- (void)setEditable:(BOOL)editable withContext:(NIBContext *)context forContext:(NSString *)name;
- (void)setEditable:(BOOL)editable withContext:(NIBContext *)context forEntity:(NSString *)entity forFilter:(NSString *)filter;
- (void)addController:(NSObjectController *)myController withContext:(NIBContext *)context;
- (NSObjectController *)getController:(int)index;
- (NSManagedObject *)getObject:(NSString *)context;
- (NSMenu *)getMenu:(NSString *)context;
- (NSView *)determineWindow:(NSView *)myWindow;
- (NSView *)processWindow:(NSView *)myWindow;

- (BOOL)isValid:(NSError **)error;
- (BOOL)isValid:(NSError **)error forEntity:(NSString *)context;
- (BOOL)isEnabled;

- (IBAction)doExecute:(id)sender;
- (IBAction)doCallback:(id)sender;

- (void)doSetup;
- (void)doValidate;
- (void)doInitialise;
- (void)doInitialiseWith:(NIBManager *)manager;
- (BOOL)doMerge:(NIBController *)controller;
+ (BOOL)doMerge:(NSManagedObject *)source toObject:(NSManagedObject *)destination;

+ (BOOL)isDynamicPopUp:(NSString*)key withMetadata:(MetadataParser *)parser;

- (void)doPopulateForKey:(NSString*)key withData:(NSDictionary *)data withMetadata:(MetadataParser *)parser withObject:(NSManagedObject *)object;
- (void)doPopulate:(NSDictionary *)data withMetadata:(MetadataParser *)parser;
- (void)doPopulate:(NSDictionary *)data withMetadata:(MetadataParser *)parser withEntity:(NSString *)context;
- (void)doPopulate:(NSDictionary *)data withMetadata:(MetadataParser *)parser withObject:(NSManagedObject *)object;
- (NSMutableDictionary *)doParse:(MetadataParser *)parser;
- (NSMutableDictionary *)doParse:(MetadataParser *)parser stringifyDates:(BOOL)stringify;
- (NSMutableDictionary *)doParse:(MetadataParser *)parser withEntity:(NSString *)context;
- (NSMutableDictionary *)doParse:(MetadataParser *)parser withEntity:(NSString *)context stringifyDates:(BOOL)stringify;
- (NSMutableDictionary *)doParse:(MetadataParser *)parser withObject:(NSManagedObject *)object stringifyDates:(BOOL)stringify;


@end
#endif /* defined INCLUDED_NIBCONTROLLER_H */
