#ifndef INCLUDED_NIBMANAGERHANDLER_H
#define INCLUDED_NIBMANAGERHANDLER_H
//
//  NIBManagerHandler.h
//  DynamicNIB
//
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@class DocumentumManager;
@class StaffwareManager;
@class MainframeManager;
@class WizardManager;
@class NIBCallback;
@class NIBContext;
@class NIBController;
@class NIBManager;
@class NIBValidator;


extern NSString*		LOCALE_ENGLISH;
extern NSString*		LOCALE_JAPANESE;
extern NSString*		KEY_IDENTIFIER;

extern int              MANAGER_STAFFWARE;
extern int              MANAGER_DOCUMENTUM;
extern int              MANAGER_PENTAHO;
extern int              MANAGER_MAINFRAME;
extern int              LOGGING_LEVEL;
extern int              LOGGING_NOTICE;
extern int              LOGGING_INFO;
extern int              LOGGING_DEBUG;

extern int              EMBEDDED;
extern int              WINDOWED;
extern int              DOCUMENT;
extern int              UNIQUE;



@interface NIBManagerHandler : NSObject {

    NSMutableDictionary *	managers;
}


+ (NIBManagerHandler *)getHandler;
+ (int)getLoggingLevel;
+ (void)setLoggingLevel:(int)level;
+ (NSString *)getLocaleIdentifier;
+ (NSString *)getBundleVersion;
+ (BOOL)isEnglish;
+ (BOOL)isJapanese;

- (void)setFlipped:(BOOL)isFlipped;
- (void)setScrolling:(BOOL)isScrolling;
- (void)setDecorated:(BOOL)isDecorated;
- (void)setBounds:(NSRect)myBounds;
- (void)setAdjustment:(NSPoint)myAdjustment;

- (NIBManager *)getManager:(NSString *)type;
- (NIBContext *)getContext:(NSString *)type withIndex:(int)index;
- (void)setManager:(NIBManager *)manager withType:(NSString *)type;
- (void)setBackingType:(NSString *)myType;
- (void)setBackingStore:(NSString *)myStore;
- (int)determineTag:(NSString *)type;

- (NIBManager *)doRegister:(NSString *)manager withType:(int)type;
- (NIBManager *)doRegister:(NSString *)manager withType:(int)type withPersistence:(int)persistence;
- (void)doInitialise:(NSString *)type withPath:(NSString *)myPath;
- (void)doInitialise:(NSString *)type withPath:(NSString *)myPath withCallback:(NIBCallback *)myCallback;
- (void)doInitialise:(NSString *)type withPath:(NSString *)myPath withCallback:(NIBCallback *)myCallback withValidator:(NIBValidator *)myValidator;


@end
#endif /* defined INCLUDED_NIBMANAGERHANDLER_H */
